Fix up all use of /dev/stderr for portability to busybox /bin/sh
[ltt-control.git] / lttctl / ltt-disarmall.sh
index 64e65a426a7280fb74e2f0bc3433a5d66294a4c9..e77be9ad92fdb72286a824b3debd0e5168ae2dcf 100755 (executable)
@@ -1,4 +1,5 @@
 # Copyright (C) 2009 Benjamin Poirier
+# Copyright (C) 2010 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # with this program; if not, write to the Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
-DEBUGFSROOT=$(grep ^debugfs /proc/mounts | head -1 | awk '{print $2}')
+DEBUGFSROOT=$(awk '{if ($3 == "debugfs") print $2}' /proc/mounts | head -n 1)
 MARKERSROOT=${DEBUGFSROOT}/ltt/markers
+DEFAULTMODULES="ltt-trace-control ltt-marker-control ltt-kprobes ltt-userspace-event ltt-statedump ipc-trace kernel-trace mm-trace net-trace fs-trace jbd2-trace syscall-trace trap-trace block-trace rcu-trace ltt-relay ltt-tracer"
+EXTRAMODULES="lockdep-trace net-extended-trace"
 
 usage () {
-       echo "Usage: $0 [OPTION]..." > /dev/stderr
-       echo "Disconnect lttng markers" > /dev/stderr
-       echo "" > /dev/stderr
-       echo "Options:" > /dev/stderr
-       printf "\t-q           Quiet mode, suppress output\n" > /dev/stderr
-       printf "\t-h           Print this help\n" > /dev/stderr
-       echo "" > /dev/stderr
+       echo "Usage: $0 [OPTION]..." 1>&2
+       echo "Disconnect lttng markers" 1>&2
+       echo "" 1>&2
+       echo "Options:" 1>&2
+       printf "\t-q           Quiet mode, suppress output\n" 1>&2
+       printf "\t-h           Print this help\n" 1>&2
+       echo "" 1>&2
 }
 
+if [ "$(id -u)" != "0" ]; then
+       echo "Error: This script needs to be run as root." 1>&2
+       exit 1;
+fi
+
 if [ ! "${DEBUGFSROOT}" ]; then
-       echo "Error: debugfs not mounted" > /dev/stderr
+       echo "Error: debugfs not mounted" 1>&2
        exit 1;
 fi
 
 if [ ! -d "${MARKERSROOT}" ]; then
-       echo "Error: LTT trace controller not found (did you compile and load LTTng?)" > /dev/stderr
+       echo "Error: LTT trace controller not found (did you compile and load LTTng?)" 1>&2
        exit 1;
 fi
 
@@ -48,7 +56,7 @@ while getopts "qh" options; do
 done
 shift $((${OPTIND} - 1))
 
-(eval "find '${MARKERSROOT}' -name metadata -prune -o -name enable -print0") | while read -r -d $'\0' marker; do
+(eval "find '${MARKERSROOT}' -name metadata -prune -o -name enable -print") | while read -r marker; do
        grep "^1$" "${marker}" -q
        if [ $? -ne 0 ]; then
                continue
@@ -58,3 +66,12 @@ shift $((${OPTIND} - 1))
        fi
        echo 0 > ${marker}
 done
+
+#Unload the kernel modules
+for i in ${EXTRAMODULES}; do
+       rmmod $i 2> /dev/null
+done
+for i in ${DEFAULTMODULES}; do
+       rmmod $i
+done
+
This page took 0.02364 seconds and 4 git commands to generate.